#!/bin/ash
#alternative script driven tray report script to be used with pmmon5
#290311 by goingnuts primary for use in pupngo
#include the following in /root/.jwmrc-tray:
#					<Swallow name="pmmon5">
#					pmmon5.sh
#					</Swallow>
#and restart jwm
#010511: changed a lots of cat/sed coding as lupo525 kernel wouldent run - what is it with that kernel?
#{ cat $TMPFL|Z1|Z2|Z3 > $TMPFL;} works fine in P412 and P431 but not in Lupo525 or with its kernel
#needed to change to: { cat $TMPFL|Z1|Z2|Z3 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

export MY_PID=$$	#prevent multible scripts running if jwm restarted
TMPFL=/tmp/new.xpm	#temp sandbox xpm
rm -f /tmp/pmmon5error.log
sync
exec 2>/tmp/pmmon5error.log

###################################################################################
#below the 2 main configurations to be done in this script (pmmon5_start and delay)
pmmon5_start () {
#configure actions onclick below
pmmon5 -n "pmmon5" -lc1 "xmixer &" -rc1 "mute &" -lc5 "rxvt -e df &" -rc5 "rxvt -e top &" -u 5 &
}

delay () {
#xpm generation delay
sleep 5
}

###################################################################################

create_free_master () {
#master for pmfree
cat > $TMPFL <<EOF
$TOP
$BUTTOM_FREE
EOF
}

create_vol_master () {
#master for pmvol
cat > $TMPFL <<EOF
$TOP
$BUTTOM_VOL
EOF
}

create_load_master () {
#master for pmload
cat > $TMPFL <<EOF
$TOP
$BUTTOM_LOAD
EOF
}

create_net_master () {
#master for pmnet
cat > $TMPFL <<EOF
$TOP_NET
EOF
}

create_bat_master () {
#master for pmbat
cat > $TMPFL <<EOF
$TOP
$BUTTOM_BAT
EOF
}

TOP_NET='/* XPM */
static char * px_xpm[] = {
"33 23 25 2",
"p 	c #ABB5AB",
"s 	c #899383",
"r 	c #3E463E",
"A0	c #899383",
"A1	c #899383",
"A2	c #899383",
"A3	c #899383",
"A4	c #899383",
"A5	c #899383",
"A6	c #899383",
"A7	c #899383",
"A8	c #899383",
"A9	c #899383",
"B0	c #899383",
"B1	c #899383",
"B2	c #899383",
"B3	c #899383",
"B4	c #899383",
"B5	c #899383",
"B6	c #899383",
"B7	c #899383",
"B8	c #899383",
"B9	c #899383",
"E0	c #899383",
"E1	c #899383",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p r r r r r r r r r r r r r r r r r r r r r r p p p p p p p p p p p ",
"p r B0B0B1B1B2B2B3B3B4B4B5B5B6B6B7B7B8B8B9B9r p r r r p r p r p p p ",
"p r B0B0B1B1B2B2B3B3B4B4B5B5B6B6B7B7B8B8B9B9r p p r p p r p r p p p ",
"p r B0B0B1B1B2B2B3B3B4B4B5B5B6B6B7B7B8B8B9B9r p p r p p p r p p p p ",
"p r B0B0B1B1B2B2B3B3B4B4B5B5B6B6B7B7B8B8B9B9r p p r p p r p r p p p ",
"p r B0B0B1B1B2B2B3B3B4B4B5B5B6B6B7B7B8B8B9B9r p p r p p r p r p p p ",
"p r r r r r r r r r r r r r r r r r r r r r r p p p p p p p p p p p ",
"p r A0A0A1A1A2A2A3A3A4A4A5A5A6A6A7A7A8A8A9A9r p r r r p r p r p p p ",
"p r A0A0A1A1A2A2A3A3A4A4A5A5A6A6A7A7A8A8A9A9r p r p r p r p r p p p ",
"p r A0A0A1A1A2A2A3A3A4A4A5A5A6A6A7A7A8A8A9A9r p r r p p p r p p p p ",
"p r A0A0A1A1A2A2A3A3A4A4A5A5A6A6A7A7A8A8A9A9r p r p r p r p r p p p ",
"p r A0A0A1A1A2A2A3A3A4A4A5A5A6A6A7A7A8A8A9A9r p r p r p r p r p p p ",
"p r r r r r r r r r r r r r r r r r r r r r r p p p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p E0E0E0E0E0E0p p p E1p p p p p E1p p r p r p r r r p r r r p ",
"p p p p E0p p p p E0p p p E1p E1E1E1p E1p p r r r p r p p p p r p p ",
"p p p p E0p p p p E0p p p E1p E1E1E1p E1p p r r r p r r r p p r p p ",
"p p p p E0p p p p E0p p p E1p p E1p p E1p p r p r p r p p p p r p p ",
"p p p p E0E0E0E0E0E0p p p p p p E1p p p p p r p r p r r r p p r p p ",
"p p p p p p E0E0p p p p p p p p E1p p p p p p p p p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p "
};'

TOP='/* XPM */
static char * px_xpm[] = {
"33 23 64 2",
"p 	c #ABB5AB",
"r 	c #899383",
"s 	c #3E463E",
"X1 c #899383",
"X2 c #899383",
"X3 c #899383",
"X4 c #899383",
"X5 c #899383",
"X6 c #899383",
"X7 c #899383",
"Y1 c #899383",
"Y2 c #899383",
"Y3 c #899383",
"Y4 c #899383",
"Y5 c #899383",
"Y6 c #899383",
"Y7 c #899383",
"Z1 c #899383",
"Z2 c #899383",
"Z3 c #899383",
"Z4 c #899383",
"Z5 c #899383",
"Z6 c #899383",
"Z7 c #899383",
"K1 c #ABB5AB",
"K2 c #ABB5AB",
"K3 c #ABB5AB",
"K4 c #ABB5AB",
"K5 c #ABB5AB",
"K6 c #ABB5AB",
"K7 c #ABB5AB",
"K8 c #ABB5AB",
"K9 c #ABB5AB",
"L1 c #ABB5AB",
"L2 c #ABB5AB",
"L3 c #ABB5AB",
"L4 c #ABB5AB",
"L5 c #ABB5AB",
"L6 c #ABB5AB",
"L7 c #ABB5AB",
"L8 c #ABB5AB",
"L9 c #ABB5AB",
"M1 c #899383",
"N1 c #899383",
"O1 c #ABB5AB",
"O2 c #ABB5AB",
"O3 c #ABB5AB",
"O4 c #ABB5AB",
"O5 c #ABB5AB",
"O6 c #ABB5AB",
"O7 c #ABB5AB",
"O8 c #ABB5AB",
"O9 c #ABB5AB",
"P1 c #ABB5AB",
"P2 c #ABB5AB",
"P3 c #ABB5AB",
"P4 c #ABB5AB",
"P5 c #ABB5AB",
"P6 c #ABB5AB",
"P7 c #ABB5AB",
"P8 c #ABB5AB",
"A1 c #899383",
"A2 c #899383",
"E1 c #ABB5AB",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p Y3Y3Y3Y3p p p p p X3X3X3X3p p p p p Z3Z3Z3Z3p p p p p p p p p p ",
"p Y6p Y3Y3p Y1p p p X6p X3X3p X1p p p Z6p Z3Z3p Z1p p p p p p p p p ",
"p Y6Y6p p Y1Y1p p p X6X6p p X1X1p p p Z6Z6p p Z1Z1p p p p p p p p p ",
"p Y6Y6p p Y1Y1p p p X6X6p p X1X1p p p Z6Z6p p Z1Z1p p p p p p p p p ",
"p Y6Y6p p Y1Y1p p p X6X6p p X1X1p p p Z6Z6p p Z1Z1p p p p p p p p p ",
"p Y6Y6p p Y1Y1p p p X6X6p p X1X1p p p Z6Z6p p Z1Z1p p p p p p p p p ",
"p Y6p Y4Y4p Y1p p p X6p X4X4p X1p p p Z6p Z4Z4p Z1p p p p p p p p p ",
"p p Y4Y4Y4Y4p p p p p X4X4X4X4p p p p p Z4Z4Z4Z4p p p p p p p p p p ",
"p Y7p p p p Y2p p p X7p p p p X2p p p Z7p p p p Z2p p p p p p p p p ",
"p Y7Y7p p Y2Y2p p p X7X7p p X2X2p p p Z7Z7p p Z2Z2p K1K6L2L7O3O8P4p ",
"p Y7Y7p p Y2Y2p p p X7X7p p X2X2p p p Z7Z7p p Z2Z2p K2K7L3L8O4O9P5p ",
"p Y7Y7p p Y2Y2p p p X7X7p p X2X2p p p Z7Z7p p Z2Z2p K3K8L4L9O5P1P6p ",
"p Y7p Y5Y5p Y2p M1p X7p X5X5p X2p N1p Z7p Z5Z5p Z2p K4K9L5O1O6P2P7p ",
"p p Y5Y5Y5Y5p p M1p p X5X5X5X5p p N1p p Z5Z5Z5Z5p p K5L1L6O2O7P3P8p ",'

BUTTOM_FREE='"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p p p p p p s s s p s s p p p s s s p s s s p p p p p p p p p ",
"p p p p p p p p p s p p p s p s p p s p p p s p p p p p p p p p p p ",
"p p p p p p p p p s s p p s s p p p s s p p s s p p p p p p p p p p ",
"p p p p p p p p p s p p p s p s p p s p p p s p p p p p p p p p p p ",
"p p p p p p p p p s p p p s p s p p s s s p s s s p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p "
};'

BUTTOM_VOL='"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p p s p s p p s p p s p p p s p s p p s p s p s s s p p p p p ",
"p p p p p s p s p s p s p s p p p s p s p p s s s p s p p p p p p p ",
"p p p p p s p s p s p s p s p p p s p s p p s p s p s s p p p p p p ",
"p p p p p s p s p s p s p s p p p s p s p p s p s p s p p p p p p p ",
"p p p p p p s p p p s p p s s s p s s s p p s p s p s s s p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p "
};'

BUTTOM_BAT='"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p A1A1A1A1A1A1A1A1A1A1A1A1p p p p p p p p p p p A2A2A2A2A2p p p p p ",
"p A1p p p p p p p p p p A1A1A1p p p p A2A2p p A2p p p p A2A2A2p p p ",
"p A1p p p p p p p p p p A1p A1p p p A2p p A2A2A2p p p p A2p p p p p ",
"p A1p p p p p p p p p p A1p A1p p p p p p p A2A2p p p p A2p p p p p ",
"p A1p p p p p p p p p p A1A1A1p p p p p p p p A2p p p p A2A2A2p p p ",
"p A1A1A1A1A1A1A1A1A1A1A1A1p p p p p p p p p p p A2A2A2A2A2p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p "
};'

BUTTOM_LOAD='"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p p p p s p s p s p p p p s p p s s s p s s p p p p p p p p p ",
"p p p p p p p s p s p s p p p s p s p s p s p s p s p p p p p p p p ",
"p p p p p p p p s p p s p p p s p s p s s s p s p s p p p p p p p p ",
"p p p p p p p s p s p s p p p s p s p s p s p s p s p p p p p p p p ",
"p p p p p p p s p s p s s s p p s p p s p s p s s p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p ",
"p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p p "
};'

#replace single units below
Z1 () { sed 's/Z1/s /g'; }
Z2 () { sed 's/Z2/s /g'; }
Z3 () { sed 's/Z3/s /g'; }
Z4 () { sed 's/Z4/s /g'; }
Z5 () { sed 's/Z5/s /g'; } 
Z6 () { sed 's/Z6/s /g'; }
Z7 () { sed 's/Z7/s /g'; }
X1 () { sed 's/X1/s /g'; }
X2 () { sed 's/X2/s /g'; }
X3 () { sed 's/X3/s /g'; }
X4 () { sed 's/X4/s /g'; }
X5 () { sed 's/X5/s /g'; }
X6 () { sed 's/X6/s /g'; }
X7 () { sed 's/X7/s /g'; }
Y1 () { sed 's/Y1/s /g'; }
Y2 () { sed 's/Y2/s /g'; }
Y3 () { sed 's/Y3/s /g'; }
Y4 () { sed 's/Y4/s /g'; }
Y5 () { sed 's/Y5/s /g'; }
Y6 () { sed 's/Y6/s /g'; }
Y7 () { sed 's/Y7/s /g'; }

K1 () { sed 's/K1/s /g'; }
K2 () { sed 's/K2/s /g'; }
K3 () { sed 's/K3/s /g'; }
K4 () { sed 's/K4/s /g'; }
K5 () { sed 's/K5/s /g'; }
K6 () { sed 's/K6/s /g'; }
K7 () { sed 's/K7/s /g'; }
K8 () { sed 's/K8/s /g'; }
K9 () { sed 's/K9/s /g'; }

L1 () { sed 's/L1/s /g'; }
L2 () { sed 's/L2/s /g'; }
L3 () { sed 's/L3/s /g'; }
L4 () { sed 's/L4/s /g'; }
L5 () { sed 's/L5/s /g'; }
L6 () { sed 's/L6/s /g'; }
L7 () { sed 's/L7/s /g'; }
L8 () { sed 's/L8/s /g'; }
L9 () { sed 's/L9/s /g'; }

M1 () { sed 's/M1/s /g'; }

N1 () { sed 's/N1/s /g'; }

O1 () { sed 's/O1/s /g'; }
O2 () { sed 's/O2/s /g'; }
O3 () { sed 's/O3/s /g'; }
O4 () { sed 's/O4/s /g'; }
O5 () { sed 's/O5/s /g'; }
O6 () { sed 's/O6/s /g'; }
O7 () { sed 's/O7/s /g'; }
O8 () { sed 's/O8/s /g'; }
O9 () { sed 's/O9/s /g'; }	

P1 () { sed 's/P1/s /g'; }
P2 () { sed 's/P2/s /g'; }
P3 () { sed 's/P3/s /g'; }
P4 () { sed 's/P4/s /g'; }
P5 () { sed 's/P5/s /g'; }
P6 () { sed 's/P6/s /g'; }
P7 () { sed 's/P7/s /g'; }
P8 () { sed 's/P8/s /g'; }
P9 () { sed 's/P9/s /g'; } #not used

#highlight single digit below
hl_000 () { cat $TMPFL|Z1|Z2|Z3|Z5|Z6|Z7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_001 () { cat $TMPFL|Z1|Z2 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_002 () { cat $TMPFL|Z1|Z3|Z4|Z5|Z7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_003 () { cat $TMPFL|Z1|Z2|Z3|Z4|Z5 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_004 () { cat $TMPFL|Z1|Z2|Z4|Z6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_005 () { cat $TMPFL|Z2|Z3|Z4|Z5|Z6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_006 () { cat $TMPFL|Z2|Z3|Z4|Z5|Z6|Z7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_007 () { cat $TMPFL|Z1|Z2|Z3 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_008 () { cat $TMPFL|Z1|Z2|Z3|Z4|Z5|Z6|Z7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_009 () { cat $TMPFL|Z1|Z2|Z3|Z4|Z6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

hl_00 () { cat $TMPFL|X1|X2|X3|X5|X6|X7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_01 () { cat $TMPFL|X1|X2 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_02 () { cat $TMPFL|X1|X3|X4|X5|X7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_03 () { cat $TMPFL|X1|X2|X3|X4|X5 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_04 () { cat $TMPFL|X1|X2|X4|X6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_05 () { cat $TMPFL|X2|X3|X4|X5|X6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_06 () { cat $TMPFL|X2|X3|X4|X5|X6|X7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_07 () { cat $TMPFL|X1|X2|X3 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_08 () { cat $TMPFL|X1|X2|X3|X4|X5|X6|X7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_09 () { cat $TMPFL|X1|X2|X3|X4|X6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

hl_0 () { cat $TMPFL|Y1|Y2|Y3|Y5|Y6|Y7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_1 () { cat $TMPFL|Y1|Y2 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_2 () { cat $TMPFL|Y1|Y3|Y4|Y5|Y7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_3 () { cat $TMPFL|Y1|Y2|Y3|Y4|Y5 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_4 () { cat $TMPFL|Y1|Y2|Y4|Y6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_5 () { cat $TMPFL|Y2|Y3|Y4|Y5|Y6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_6 () { cat $TMPFL|Y2|Y3|Y4|Y5|Y6|Y7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_7 () { cat $TMPFL|Y1|Y2|Y3 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_8 () { cat $TMPFL|Y1|Y2|Y3|Y4|Y5|Y6|Y7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}
hl_9 () { cat $TMPFL|Y1|Y2|Y3|Y4|Y6 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

hl_Mb () { cat $TMPFL |K1|K2|K3|K4|K5|K7|L2|L3|L4|L5|L6|O3|O4|O5|O6|O7|O8|P1|P3|P5|P7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

hl_Gb () { cat $TMPFL|K1|K2|K3|K4|K5|K6|K8|L1|L2|L4|L5|L6|O3|O4|O5|O6|O7|O8|P1|P3|P5|P7> $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

hl_pct () { cat $TMPFL|K1|K2|K5|K6|K7|K9|L4|L8|O3|O1|O2|O6|O7 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

hl_DECIMAL1 () { cat $TMPFL|M1 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}

hl_DECIMAL2 () { cat $TMPFL|N1 > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;}


fix_colors () {
cat $TMPFL | sed 's/s  c #899383/s 	c #3E463E/g' > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;
cat $TMPFL | sed 's/s  c #ABB5AB/s 	c #3E463E/g' > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL;
}

digit2xpm () {
NUMBER=$1
UNIT=$2
TARGET=$3

#new number convert - we recive 3 digits and 0 or 1 delimiter
FIRST=$(echo $NUMBER | busybox cut -b1)
SECOND=$(echo $NUMBER | busybox cut -b2)
THIRD=$(echo $NUMBER | busybox cut -b3) 
FORTH=$(echo $NUMBER| busybox cut -b4) 
mylength=$(echo $NUMBER | wc -c)

case ${mylength} in 
  2) hl_00${FIRST};;
  3) hl_00${SECOND}
     hl_0${FIRST};;
  4) hl_00${THIRD}
     [ ! "${SECOND}" = "." ] && hl_0${SECOND} || hl_DECIMAL2
     [ ! "${FIRST}" = "." ] && hl_${FIRST} || hl_DECIMAL1;;
  5) hl_00${FORTH}
     [ ! "${THIRD}" = "." ] && hl_0${THIRD} || hl_DECIMAL2
     [ ! "${SECOND}" = "." ] && hl_${SECOND} || hl_DECIMAL1
     hl_${FIRST};;
  *) echo "ERROR!";;
esac

case ${UNIT} in
  Mb) hl_Mb;;
  Gb) hl_Gb;;
  pct) hl_pct;;
  #*) echo "No unit needed";;
esac

fix_colors
cp -f $TMPFL $TARGET	#/tmp/p5.xpm	
}

pmfree () {
#free space on savepart/ramdisk
if [ $LAYER -eq 1 ]; then
  fp=$(df -m | grep ' /$' | tr -s ' ' | cut -f 4 -d ' ')
else
  fp=$(df -m | grep '/pup_ro1$' | tr -s ' ' | cut -f 4 -d ' ')
fi

#problem with lupo with above as rootfs and unionfs both reports so ensure only one number (no space)

fp="$(echo $fp | cut -d " " -f1) "

fb_alert=$fp
mylength=$(echo $fp | wc -c)
 
case ${mylength} in
  2|3|4) UNIT=Mb;;
      5) UNIT=Gb
         fp1=$(echo $fp | busybox cut -b1)	
         fp2=$(echo $fp | busybox cut -b2-3)
         fp="$fp1.$fp2";;	#gives x.xx GB
      6) UNIT=Gb
         fp1=$(echo $fp | busybox cut -b1-2)	
         fp2=$(echo $fp | busybox cut -b3-4)
         fp="$fp1.$fp2";;	#gives xx.x GB  
      7) UNIT=Gb
         fp=$(echo $fp | busybox cut -b1-3);;	#gives xxx GB 
      *) echo "ERROR!";;		#who have save files i 0 or Tb size???
esac
   
#call the digit2xpm - but only if value has changed
if [ ! "${OLDFREE}" = "${fp}" ] && [ ! "${fp}" = "" ]; then	#might also test for unit???
  create_free_master
  digit2xpm $fp $UNIT /tmp/p5.xpm
fi
  
OLDFREE=$fp	#save present value to compare future runs
  
#check for low space
if [ $fb_alert -le $LOW_FLASH ]; then
  cat /tmp/p5.xpm | sed 's/s 	c #3E463E/s  c #FF0000/g' > /tmp/p5.xpm.tmp; mv /tmp/p5.xpm.tmp /tmp/p5.xpm
fi
}

pmvol () {
if [ ! "$(which aumix)" = "" ]; then
  VOL=$(aumix -q | grep vol | cut -d " " -f2 | tr -d ",")
  UNIT=pct
  #only update xpm if any change
  #if [ ! "${OLDVOL}" = "${VOL}" ]; then	#maybe prevent no image?
    create_vol_master
    #precaution
    [ "${VOL}" = "" ] && VOL=0
    digit2xpm $VOL $UNIT /tmp/p1.xpm
    hl_pct
  #fi
  OLDVOL=${VOL}
fi	
}

pmload () {
LOAD=$(cat /proc/loadavg | cut -d " " -f1)
if [ ! "${OLDLOAD}" = "${LOAD}" ]; then
  create_load_master
  digit2xpm ${LOAD} dummy /tmp/p2.xpm
fi
OLDLOAD=${LOAD}

COLOUR=$(echo $LOAD | cut -b1)
if [ ${COLOUR} -ge 1 ]; then
  cat /tmp/p2.xpm | sed 's/s 	c #3E463E/s  c #FF0000/g' > /tmp/p2.xpm.tmp; mv /tmp/p2.xpm.tmp /tmp/p2.xpm
fi
}

pmnet () {
create_net_master
#check for eth
ETH=$(ifconfig | grep eth | cut -d " " -f1)
if [ ! "${ETH}" = "" ]; then
  cat $TMPFL | sed 's/E0	c #899383/E0 c #3E463E/g' > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL	
fi
#check for wlan
WLAN=$(ifconfig | grep wlan | cut -d " " -f1)
if [ ! "${WLAN}" = "" ]; then
  cat $TMPFL | sed 's/E1	c #899383/E1 c #3E463E/g' > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL	
fi
if [ ! "${ETH}" = "" ] || [ ! "${WLAN}" = "" ]; then
  DOWN=$(awk '{print $2}' /proc/net/dev) 
  DOWN=$(echo $DOWN | cut -d " " -f3-20)
  SUM_DOWN=0
  for X in ${DOWN}; do
    let SUM_DOWN=SUM_DOWN+X
  done
  UP=$(awk '{print $10}' /proc/net/dev) 
  UP=$(echo $UP | cut -d " " -f2-20)
  SUM_UP=0
  for X in ${UP}; do
    let SUM_UP=SUM_UP+X
  done
  DOWN=${SUM_DOWN}
  UP=${SUM_UP}
else
  DOWN=0
  UP=0
fi
  if [ ! "${DOWN}" = "" ] && [ ! "${UP}" = "" ]; then
    #copy rx history
    B_0=$B_1;B_1=$B_2;B_2=$B_3;B_3=$B_4;B_4=$B_5;B_5=$B_6;B_6=$B_7;B_7=$B_8;B_8=$B_9;
    #copy tx history
    A_0=$A_1;A_1=$A_2;A_2=$A_3;A_3=$A_4;A_4=$A_5;A_5=$A_6;A_6=$A_7;A_7=$A_8;A_8=$A_9;
    [ ${DOWN_OLD} -eq ${DOWN} ] && B_9=0 || B_9=1
    [ ${UP_OLD} -eq ${UP} ] && A_9=0 || A_9=1
    #graph fill rx
    [ $B_0 -gt 0 ] && cat $TMPFL|sed 's/A0	c #899383/A0 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_1 -gt 0 ] && cat $TMPFL|sed 's/A1	c #899383/A1 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_2 -gt 0 ] && cat $TMPFL|sed 's/A2	c #899383/A2 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_3 -gt 0 ] && cat $TMPFL|sed 's/A3	c #899383/A3 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_4 -gt 0 ] && cat $TMPFL|sed 's/A4	c #899383/A4 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_5 -gt 0 ] && cat $TMPFL|sed 's/A5	c #899383/A5 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_6 -gt 0 ] && cat $TMPFL|sed 's/A6	c #899383/A6 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_7 -gt 0 ] && cat $TMPFL|sed 's/A7	c #899383/A7 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_8 -gt 0 ] && cat $TMPFL|sed 's/A8	c #899383/A8 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $B_9 -gt 0 ] && cat $TMPFL|sed 's/A9	c #899383/A9 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    #graph fill tx
    [ $A_0 -gt 0 ] && cat $TMPFL|sed 's/B0	c #899383/B0 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_1 -gt 0 ] && cat $TMPFL|sed 's/B1	c #899383/B1 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_2 -gt 0 ] && cat $TMPFL|sed 's/B2	c #899383/B2 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_3 -gt 0 ] && cat $TMPFL|sed 's/B3	c #899383/B3 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_4 -gt 0 ] && cat $TMPFL|sed 's/B4	c #899383/B4 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_5 -gt 0 ] && cat $TMPFL|sed 's/B5	c #899383/B5 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_6 -gt 0 ] && cat $TMPFL|sed 's/B6	c #899383/B6 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_7 -gt 0 ] && cat $TMPFL|sed 's/B7	c #899383/B7 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_8 -gt 0 ] && cat $TMPFL|sed 's/B8	c #899383/B8 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    [ $A_9 -gt 0 ] && cat $TMPFL|sed 's/B9	c #899383/B9 c #00FF00/g' > $TMPFL.tmp && mv $TMPFL.tmp $TMPFL
    DOWN_OLD=${DOWN};
    UP_OLD=${UP};
    fix_colors
  fi
  cp -f $TMPFL /tmp/p3.xpm
#fi #end ETH OR WLAN empty
}

pmbat () {
create_bat_master

if [ -d /proc/acpi/battery/ ]; then
  CURRENT=$(grep remaining /proc/acpi/battery/*/state | tr -d A-z | tr -d " " | tr -d :)
  TOTAL=$(grep "design capacity:" /proc/acpi/battery/*/info | tr -d A-z | tr -d " " |tr -d :)
  let CURRENT=CURRENT*100
  let CURRENT=CURRENT/$TOTAL
  cat $TMPFL|sed 's/A1 c #899383/A1 c #3E463E/g' > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL
  #charging
  CHARGING=$(grep "charging state" /proc/acpi/battery/*/state | cut -d ":" -f2 | tr -d " ")
  if [ "${CHARGING}" = "charging" ]; then
    cat $TMPFL|sed 's/A2 c #899383/A2 c #3E463E/g' > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL
  fi
  
  digit2xpm $CURRENT pct /tmp/p4.xpm
  #alarm
  if [ $CURRENT -le 10 ]; then
    cat /tmp/p4.xpm | sed 's/s 	c #3E463E/s  c #FF0000/g' > /tmp/p4.xpm.tmp; mv /tmp/p4.xpm.tmp /tmp/p4.xpm
  fi 
  
else
 # if [ -f /proc/apm ]; then
 #  #cant test below so do not use it
 #   CURRENT=$(cat /proc/apm | sed -e "s/^.*% //")
 #   
 #  cat $TMPFL|sed 's/A1 c #899383/A1 c #3E463E/g' > $TMPFL
 #  digit2xpm $CURRENT pct /tmp/p4.xpm 
 # else
    cat $TMPFL|sed 's/A2 c #899383/A2 c #3E463E/g' > $TMPFL.tmp; mv $TMPFL.tmp $TMPFL
    digit2xpm 100 pct /tmp/p4.xpm	
 # fi
fi
}

#MAIN pmfree2 script area below

#initialise
PUPMODE=$(grep PUPMODE /etc/rc.d/PUPSTATE | cut -d "=" -f2)
LAYER=1
LOW_FLASH=10 #10M free alert limit
[ $PUPMODE -eq 3 ] || [ $PUPMODE -eq 7 ] || [ $PUPMODE -eq 13 ] && LAYER=2	
  
killall pmmon5	#killall running pmmon
for x in $(pidof pmmon5.sh); do #kill all other but this
  if [ ! "${x}" = "${MY_PID}" ]; then
    kill $x
  fi
done


create_vol_master
cp -f /tmp/new.xpm /tmp/p1.xpm
sync
create_load_master
cp -f /tmp/new.xpm /tmp/p2.xpm
sync
create_net_master
cp -f /tmp/new.xpm /tmp/p3.xpm
sync
create_bat_master
cp -f /tmp/new.xpm /tmp/p4.xpm
sync
create_free_master
cp -f /tmp/new.xpm /tmp/p5.xpm
sync

#while [ ! -f /tmp/p1.xpm ] && [ ! -f /tmp/p2.xpm ] && [ ! -f /tmp/p3.xpm ] && [ ! -f /tmp/p4.xpm ] && [ ! -f /tmp/p5.xpm ]; do
#  sleep 1
#done

#start the projector
pmmon5_start

#for pmnet
DOWN_OLD=0;UP_OLD=0;A_0=0;A_1=0;A_2=0;A_3=0;A_4=0;A_5=0;A_6=0;A_7=0;A_8=0;A_9=0;B_0=0;B_1=0;B_2=0;B_3=0;B_4=0;B_5=0;B_6=0;B_7=0;B_8=0;B_9=0;

#main loop start

while :; do
  pmvol
  pmload
  pmnet
  pmbat
  pmfree
  delay
done

killall pmmon5
exit